{% extends '@DemosPlanCore/DemosPlanCore/base.html.twig' %}

{% set sendFinalEmail = true %}
{% if templateVars.table.statement.feedback == 'snailmail' %}
  {% if templateVars.table.statement.votes is empty %}
    {% set sendFinalEmail = false %}
  {% endif %}
{% endif %}

{% set statement = templateVars.table.statement %}
{% set procedure = templateVars.table.procedure.id %}

{% block component_part %}

    {# Header #}
    {# statement.original will be defined but null indicates this statement is an orginal statement #}
    {% include '@DemosPlanCore/DemosPlanCore/includes/base_pageheader.html.twig' with {
        heading: (statement.original is defined and statement.original is null ? 'statement.original' : 'statement')|trans
    } %}

    {# start content #}

    {% set statementDetailPath = path("dm_plan_assessment_single_view", { 'statement': statement.ident, 'procedureId': procedure }) %}

    {% set formDefinitions = {} %}
    {% for definition in templateVars.table.procedure.statementFormDefinition.fieldDefinitions %}
        {% set formDefinitions = formDefinitions|merge({ (definition.name): { id: definition.id, enabled: definition.enabled, required:definition.required } }) %}
    {% endfor %}

    <div id="itemdisplay_{{ statement.ident|default(0) }}" class="border u-ph-0_5 u-mb-0_5">

        <div class="layout--flush layout__item u-pl-0">
            {# release from cluster #}
            {% if statement.headStatement is not null %}
            {# back to cluster #}
                <div class="u-mt-0_5 inline-block">
                    <a href="{{ path("DemosPlan_cluster_view", { 'statement': statement.headStatement.ident, 'procedureId': procedure, 'isCluster': true }) }}" class="">
                        {{ "cluster.back.to"|trans }}
                    </a>
                </div>

                <form class="float-right"
                      action="{{ path('DemosPlan_cluster_detach_statement', { 'statementId': statement.ident, 'procedure': procedure }) }}">
                    <button type="submit" class="btn btn--primary u-mt-0_5" >Aus der Gruppe {{ statement.headStatement.externId }} lösen</button>
                </form>
            {% endif %}
        </div>

        {# item header #}
        <div class="border--bottom layout--flush u-pt-0_25 u-ph-0_5 flow-root">
            {% apply spaceless -%}

                {# id #}
                <div class="layout--flush layout__item">
                    <label for="{{ statement.ident }}:item_check[]" class="layout__item u-3-of-8 u-mb-0_25">
                        <span class="o-tooltip inline-block">
                            {{ 'id'|trans }}:
                            {% if statement.original.ident is defined
                                and statement.parent.ident is defined
                                and statement.parent.ident is not null
                            %}
                                {% if statement.original.ident != statement.parent.ident %}
                                    {{ 'copyof'|trans }}
                                {% endif %}
                            {% endif %}
                            {% if statement.externId is defined %}
                                {{ statement.externId }}
                            {% endif %}

                            {% if statement.headStatement is not null %}
                                | {{ 'cluster'|trans }}: {{ statement.headStatement.externId }}
                            {% endif %}

                            <span class="o-tooltip__content">
                                {% if statement.meta.authoredDate is defined and statement.meta.authoredDate|dplanDate() != '' %}
                                    {{ 'statement.date.authored'|trans }}: {{ statement.meta.authoredDate|default()|dplanDate()}} <br>
                                {% endif %}
                                {{ 'statement.date.submitted'|trans }}: {{ statement.submit|default()|dplanDate() }} <br>
                            </span>
                        </span>
                    </label>

                </div>
            {%- endapply %}
        </div>

        {# item content#}
        <div class="">

            {# statement tab #}
            <div class="is-active flow-root u-ph u-pt-0_5" data-toggle-id="{{ statement.ident|default(0) }}_statement">

                {# Einreicher #}
                {% if hasPermission('field_statement_meta_orga_name') and formDefinitions.citizenXorOrgaAndOrgaName.enabled == true %}
                    <div class="layout--flush  u-mb">
                        <span class="layout__item u-3-of-8 weight--bold">
                            {{ "submitter.invitable_institution"|trans }}
                        </span><!--
                        {% if statement.meta.orgaName is defined and statement.meta.orgaName == 'anonym' %}
                         --><span class="layout__item u-5-of-8">{{ "role.citizen"|trans }}</span><!--
                        {% else %}
                         --><span class="layout__item u-5-of-8">{{ statement.meta.orgaName|default('')}}</span><!--
                        {% endif %}
                     -->
                    </div>
                {% endif %}

                {# Abteilung #}
                {% if hasPermission('field_statement_meta_orga_department_name') and formDefinitions.citizenXorOrgaAndOrgaName.enabled == true %}
                    {% if statement.hasDefaultGuestUser == false %}
                        <div class="layout--flush u-mb">
                            <span class="layout__item u-3-of-8 weight--bold">
                                {{ "department"|trans }}
                            </span><!--
                         --><span class="layout__item u-5-of-8">{{ statement.meta.orgaDepartmentName|default('') }}</span>
                        </div>
                    {% endif %}
                {% endif %}

                {# Eingereicht von #}
                {% if hasPermission('field_statement_meta_submit_name') and formDefinitions.name.enabled == true %}
                    <div class="layout--flush u-mb">
                        <span class="layout__item u-3-of-8 weight--bold">
                            {{ "submitted.author"|trans }}
                        </span><!--
                        {% if statement.meta.submitName is defined and statement.meta.submitName != '' and statement.hasDefaultGuestUser == false %}
                         --><span class="layout__item u-5-of-8">{{ statement.meta.submitName }} {# Einreicher der manuellen Stellungnahme #}</span><!--
                        {% elseif statement.meta.submitName is defined and statement.meta.submitName == '' and statement.hasDefaultGuestUser == false %}
                         --><span class="layout__item u-5-of-8">{{ statement.meta.authorName|default('')}}{# Stellungnahme Bürger #}</span><!--
                        {% elseif statement.meta.orgaName is defined and statement.meta.orgaName != '' and statement.hasDefaultGuestUser %}
                         --><span class="layout__item u-5-of-8">{{ statement.meta.authorName|default("anonymous"|trans)}}</span><!--
                        {% endif %}
                         -->
                    </div>
                {% endif %}

                {# Eingangsnummer #}
                {% if hasPermission('field_statement_intern_id') %}
                    {% if statement.internId is defined %}
                        <div class="layout--flush u-mb">
                            <span class="layout__item u-3-of-8 weight--bold">
                                {{ "internId" |trans }}
                            </span><!--
                         --><span class="layout__item u-5-of-8">{{ statement.internId }}</span>
                        </div>
                    {% endif %}
                {% endif %}

                {# show submit type, if permission is set and value differs from 'system' (-> manual statement) #}
                {# Art der Einrichung #}
                {% if hasPermission('field_statement_submit_type') %}
                    <div class="layout--flush u-mb">
                        <span class="layout__item u-3-of-8 weight--bold">
                            {{ 'submit.type'|trans }}
                        </span><!--
                     --><span class="layout__item u-5-of-8" name="r_submit_type">
                            {% for key, translated in getFormOption('statement_submit_types.values', true) %}
                                {{ statement.submitType == key ? translated : '' }}
                            {% endfor %}
                        </span>
                    </div>
                {% endif %}

                {# Adresse und Mitzeichner nur bei Bürger-SN #}
                {% if hasPermission('field_statement_meta_address') and statement.hasDefaultGuestUser and (formDefinitions.streetAndHouseNumber.enabled == true or formDefinitions.street.enabled == true) %}
                    <div class="layout--flush u-mb">
                        <span class="layout__item u-3-of-8 weight--bold">
                            {{ "address"|trans }}
                        </span><!--
                        {% if statement.meta.orgaPostalCode|default('') != '' %}
                         --><span class="layout__item u-5-of-8">
                            {% if formDefinitions.streetAndHouseNumber.enabled == true or formDefinitions.street.enabled == true %}
                                {{ statement.meta.orgaStreet|default('')}}
                                {% if formDefinitions.streetAndHouseNumber.enabled == true %}
                                    {{ statement.meta.houseNumber|default('')}}
                                {% endif %}
                            {% endif %}

                            {% if formDefinitions.postalAndCity.enabled == true %}
                                , {{ statement.meta.orgaPostalCode|default('')}}&nbsp;
                                {{ statement.meta.orgaCity|default('')}}
                            {% endif %}
                            </span><!--
                        {% else %}
                        --><span>-</span><!--
                        {% endif %}
                     -->
                    </div>
                {% endif %}

                {# Veroeffentlichung #}
                {% if hasPermission('field_statement_public_allowed') %}
                    {% apply spaceless %}
                        <div class="layout--flush u-mb">
                            <span class="layout__item u-3-of-8 weight--bold">
                                {{ "publish.on.platform"|trans }}
                            </span>
                            {% if (statement.procedure.publicParticipationPublicationEnabled and (statement.publicCheck != 'no' and statement.publicCheck != 'filter.publicCheck.no') ) %}
                                <a href="#statementText">{{ statement.publicCheck|trans }}</a>
                            {% elseif statement.publicCheck == 'no' and statement.publicCheck != 'filter.publicCheck.no' %}
                                {{ statement.publicCheck|trans }}
                            {% else %}
                                {{ "procedure.statement.publication.disabled"|trans }}
                            {% endif %}
                        </div>
                    {% endapply %}
                {% endif %}

                {# Mitzeichnung #}
                {% if hasPermission('field_statement_votes') %}
                    <div class="layout--flush u-mb">
                        {% include '@DemosPlanCore/DemosPlanStatement/includes/vote_statement_messages.html.twig'
                           with { hideExplanations: (statement.headStatement is not null) }
                        %}
                    </div>

                    {% if hasPermission('feature_statements_vote') %}
                        {% if statement.publicAllowed is defined and statement.publicAllowed == true %}
                            <div class="layout--flush u-mb">
                                <span class="layout__item weight--bold u-3-of-8">
                                    {{ "voters"|trans }}
                                </span>
                                {% set title = '' %}
                                {% if statement.votesNum is defined and statement.votesNum == 1 %}
                                    {% set title = statement.votesNum ~ "person"|trans %}
                                {%  else %}
                                    {% set title = statement.votesNum ~ "persons"|trans %}
                                {% endif %}
                                <dp-accordion title="{{ title }}" class="u-5-of-8">
                                    <ul>
                                        {% for vote in statement.votes %}
                                            {% if vote.user is defined and vote.user != '' %}
                                                {#votes added by logged in users have a user property#}
                                                <li>
                                                    {{ vote.user.firstname }} {{ vote.user.lastname }},
                                                    {{ vote.user.address.street|default('') }},
                                                    {{ vote.user.address.postalcode|default('') }}
                                                    {{ vote.user.address.city|default('') }},
                                                    {{ vote.user.email|default('') }}
                                                </li>
                                            {% elseif vote.firstName != '' or vote.lastName != '' or vote.userPostcode != '' or vote.userCity != '' or vote.userMail != '' or vote.organisationName != '' or vote.departmentName != '' %}
                                                {#votes added manually by fachplaner#}
                                                <li>
                                                    {{ vote.firstName|default() }} {{ vote.lastName|default() }},
                                                    {{ vote.organisationName|default() }} {{ vote.departmentName|default }}
                                                    {{ vote.userPostcode|default('') }}
                                                    {{ vote.userCity|default('') }},
                                                    {{ vote.userMail|default('') }}
                                                </li>
                                            {% endif %}
                                        {% endfor %}
                                    </ul>
                                </dp-accordion>
                            </div>
                        {% endif %}
                    {% endif %}

                    {% if hasPermission('feature_statements_like') %}
                        {% if statement.publicAllowed is defined and statement.publicAllowed == true %}
                            <div class="layout--flush u-mb">
                                <span class="layout__item weight--bold u-3-of-8">
                                    {{ "liked.by"|trans }}
                                </span>
                                <div class="layout__item u-5-of-8">
                                    <i class="fa fa-caret-right"></i>
                                    {% if statement.likesNum is defined and statement.likesNum == 1 %}
                                        {{ statement.likesNum }} {{ "person"|trans }}
                                    {%  else %}
                                        {{ statement.likesNum }} {{ "persons"|trans }}
                                    {% endif %}
                                </div>
                            </div>
                        {% endif %}
                    {% endif %}
                {% endif %}

                <div id="item_{% if statement.ident is defined %}{{ statement.ident }}{% endif %}">

                    {# Verfahren #}
                    {% if hasPermission('field_procedure_name') %}
                        <div class="layout--flush u-mb">
                            <span class="layout__item u-3-of-8 weight--bold">
                                {{ "procedure"|trans }}
                            </span><!--
                         --><span class="layout__item u-5-of-8">{{ templateVars.table.procedure.name|default('') }}</span>
                        </div>
                    {% endif %}

                    {# Verfassungsdatum #}
                    {% if statement.meta.authoredDate is defined and statement.meta.authoredDate|dplanDate() != '' %}
                        <div class="layout--flush u-mb">
                            <span class="layout__item u-3-of-8 weight--bold">
                                {{ 'statement.date.authored'|trans }}
                            </span><!--
                         --><span class="layout__item u-5-of-8">{{ statement.meta.authoredDate|default()|dplanDate()}}</span>
                        </div>
                    {% endif %}

                    {# Einreichungsdatum #}
                    <div class="layout--flush u-mb">
                        <span class="layout__item u-3-of-8 weight--bold">
                            {{ 'statement.date.submitted'|trans }}
                        </span><!--
                     --><span class="layout__item u-5-of-8">{{ statement.submit|default()|dplanDate()}}</span>
                    </div>

                    {# Autor Sonstiges #}
                    {% if statement.externId is defined and statement.hasDefaultGuestUser == false %}
                        {% if 'M' in statement.externId %}
                            <div class="layout--flush u-mb">
                                <span class="layout__item u-3-of-8 lbl weight--bold">
                                    {{ "author.misc"|trans }}
                                </span><!--
                             --><span class="layout__item u-5-of-8">
                                    {% if sendFinalEmail == false %}
                                        {{ "statement.final.send.postal"|trans }}<br>
                                    {% endif %}
                                    {{ statement.meta.orgaEmail|default('----') }}
                                    <br>{{ statement.meta.orgaStreet|default('----') }} {{ statement.meta.houseNumber|default('----') }}
                                    <br>{{ statement.meta.orgaPostalCode|default('----') }}
                                    &nbsp;{{ statement.meta.orgaCity|default('----') }}
                                </span>
                            </div>
                        {% endif %}
                    {% endif %}
                </div>

                {# location #}
                {% if (formDefinitions.countyReference.enabled == true or formDefinitions.mapAndCountyReference.enabled == true) and (hasPermission('field_statement_county') or hasPermission('field_statement_municipality') or procedureStatementPriorityArea) %}
                    <div class="layout--flush u-mb">
                        {%- apply spaceless %}
                        <div class="layout__item u-3-of-8 weight--bold">
                            {{ "location"|trans }}
                        </div>

                        <span class="layout__item u-5-of-8">
                            {% if statement.countyNames|default([])|merge(statement.priorityAreaKeys|default([]))|merge(statement.municipalityNames|default([]))|length > 0 %}

                                {% if statement.countyNames|default([])|length > 0 %}
                                    <span class="weight--bold">
                                        {{ "counties"|trans }}:
                                    </span>
                                    <span>
                                        {% for county in statement.countyNames %}
                                            {{ county }}{{ loop.last ? '' : ', ' }}
                                        {% endfor %}
                                    </span>
                                    <br>
                                {% endif %}

                                {% if statement.priorityAreaKeys|default([])|length > 0 and formDefinitions.mapAndCountyReference.enabled == true %}
                                    <span class="weight--bold">
                                        {{ "priorityAreas.all"|trans }}:
                                    </span>
                                    <span>
                                        {% for priorityArea in statement.priorityAreaKeys %}
                                            {{ priorityArea }}{{ loop.last ? '' : ', ' }}
                                        {% endfor %}
                                    </span>
                                    <br>
                                {% endif %}

                                {% if statement.municipalityNames|default([])|length > 0 and formDefinitions.mapAndCountyReference.enabled == true %}
                                    <span class="weight--bold">
                                        {{ "municipalities"|trans }}:
                                    </span>
                                    <span>
                                        {% for municipality in statement.municipalityNames %}
                                            {{ municipality }}{{ loop.last ? '' : ', ' }}
                                        {% endfor %}
                                    </span>
                                {% endif %}

                            {% else %}

                                <span>{{ "location.notassigned"|trans }}</span>

                            {% endif %}

                        </span>
                        {% endapply -%}
                    </div>
                {% endif %}

                {# Dokument, Kapitel #}
                {% if hasPermission('field_procedure_elements') %}
                    <div class="layout--flush u-mb">
                        {%- apply spaceless %}
                        <div class="layout__item u-3-of-8 weight--bold">
                            {{ 'elements.assigned'|trans }}:
                        </div>

                        <span class="layout__item u-5-of-8">

                            {% if statement.elementTitle|default != '' %}

                                {% if ('paragraph' == statement.elementCategory|default ) %}
                                    {% set link = path('DemosPlan_public_plandocument_paragraph',{'procedure':statement.pId, 'elementId':statement.elementId|default }) %}
                                {% endif %}

                                <span class="weight--bold">
                                    {{ 'document'|trans }}:
                                </span>
                                <span>
                                    <a href="{{ link|default('#') }}" title="{{ statement.elementTitle|default }}">{{ statement.elementTitle|default('document.notavailable'|trans) }}</a>
                                </span>

                                {% if statement.paragraphTitle|default is not null %}
                                    <br>
                                    <span class="weight--bold">
                                        {{ "paragraph"|trans }}:
                                    </span>
                                    <span>
                                        {{ statement.paragraphTitle|default }}
                                    </span>
                                {% endif %}

                            {% else %}

                                {{ "element.notassigned"|trans }}

                            {% endif %}

                        </span>
                        {% endapply -%}
                    </div>
                {% endif %}

                {#tags#}
                {% if hasPermission('feature_statements_tag') %}
                    <div class="layout--flush u-mb">
                        {%- apply spaceless %}
                            <div class="layout__item u-3-of-8 weight--bold">
                                {{ 'tags.assigned'|trans }}:
                            </div>

                            <span class="layout__item u-5-of-8">
                            {% if statement.tags|length > 0 %}
                                {{ statement.tags|map(tag => tag.title)|join(', ') }}
                            {% else %}

                                {{ "tags.notassigned"|trans }}

                            {% endif %}

                        </span>
                        {% endapply -%}
                    </div>
                {% endif %}

                {# attachment original file #}
                {% set source_statements = statement.attachments|default([])|filter(el => el.type == 'source_statement') %}
                {% if source_statements|length > 0 %}
                    {%- apply spaceless %}
                        <div class="layout--flush u-mb">
                            <div class="layout__item weight--bold u-3-of-8">
                                {{ "attachment.original"|trans}}:
                            </div>
                            <span class="layout__item u-5-of-8">
                                <i
                                    class="fa fa-paperclip color--grey inline"
                                    title="{{ 'attachment.original'|trans }}"
                                    aria-hidden="true">
                                </i>
                                {% for source_stn in source_statements %}
                                    {% if hasPermission('feature_read_source_statement_via_api') %}
                                        <a
                                            class="o-hellip--nowrap u-mb-0_25 inline"
                                            title="{{ source_stn.file.name|default('original.pdf'|trans) }}"
                                            target="_blank"
                                            rel="noopener noreferrer"
                                            href="{{ path("core_file", { 'hash': source_stn.file.hash|default }) }}">
                                            {{ source_stn.file.name|default('original.pdf'|trans) }}
                                        </a>
                                    {% endif %}
                                {% endfor %}
                        </span>
                        </div>
                    {% endapply -%}
                {% endif %}


                {# files #}
                {% if hasPermission('field_procedure_documents') %}
                    {% if statement.files|default|length > 0 %}
                        {%- apply spaceless %}
                            <div class="layout--flush u-mb">
                                <div class="layout__item u-3-of-8 weight--bold">
                                    {{ "attachments"|trans}}:
                                </div>
                                <span class="layout__item u-5-of-8">
                                    {% include '@DemosPlanCore/DemosPlanAssessmentTable/DemosPlan/dhtml/v1/includes/item/files.html.twig' %}
                                </span>
                            </div>
                        {% endapply -%}
                    {% endif %}
                {% endif %}

                {# statement inhalte #}
                <div class="layout--flush u-mb">
                    {%- apply spaceless %}
                    <div class="layout__item u-3-of-8 weight--bold">
                        {{ "statement.text"|trans}}
                    </div>
                    <span class="layout__item u-5-of-8" id="statementText">
                        {% set statementTextHeightShortened = statement.text|default("notspecified"|trans)|heightLimitShorten %}
                        <dp-height-limit
                            short-text="{{ statementTextHeightShortened|default("notspecified"|trans) }}"
                            full-text="{{ statement.text|default("notspecified"|trans) }}"
                            :is-shortened="{{ statementTextHeightShortened|length }} < {{ statement.text|length }}"
                            element="statement"
                            no-event
                            class="c-styled-html u-mr"
                        ></dp-height-limit>
                    </span>
                    {% endapply -%}
                </div>

                {# statement note #}
                <div class="layout--flush u-mb">
                    {%- apply spaceless %}
                    <div class="layout__item u-3-of-8 weight--bold">
                        {{ "memo"|trans}}
                    </div>
                    <span class="layout__item u-5-of-8">
                        {{ statement.memo|default("memo.unset"|trans) }}
                    </span>
                    {% endapply -%}
                </div>
            </div>

        </div>

    </div>

{% endblock component_part %}

{% block javascripts %}
    {{ parent() }}
    {{ webpackBundle('statement-viewStatement.js') }}
{% endblock javascripts %}
